#ifndef	_GPROG_H
#define _GPROG_H

#include "ktext.h"
#include "gvar.h"
#include "gcommon.h"
#include "message.h"
#include "r_obj.h"

class GProgramText
{
  RealObject* src_code;
  Segment* seg;
  SYMBOL rtn;
  TC* string;
  W number;
  LINK* v_link;
  B* v_segData;
	
public:
  GProgramText();
  GProgramText(RealObject *src);
  ~GProgramText();
	
public:
  TC getc();
  TC getc2();
  TC ungetc(TC c);
  SYMBOL lex();
  void setText(RealObject *src);
	
private:
  W geti();
  TC *getDigit(TC *p);
  void skip_for(TC c);
	
public:
  TC *getString() {
    return string;
  }
  TC getChar() {
    return string[0];
  }
  W getNumber() {
    return number;
  }
  LINK* getLink() {
    return v_link;
  }
  B* getSegment() {
    return v_segData;
  }
  SYMBOL getReturn() {
    return rtn;
  }
};

class GVariableList;

class GProgram
{
  GProgramText *progText;
  GVariableList *varList;
  GProgramList *progList;
  GCalc *progEndPointer;
  CMessage *mes;
	
public:
  GProgram();
  ~GProgram();
	
protected:
  int variable();
  void condition();
  void factor();
  void term();
  void expression();
  void statement();
	
  void assign();
  void argument();
  void function();
  void if_proc();
  void while_proc();
  void println_proc();
  void vopen_proc();

  void init();
	
public:
  void compile_init();
  void compile_end();
  void compile(RealObject *p, SRC_TYPE src_type);
  void execute();
	
  GCalc *getProgramEnd() {
    return progList->getEndP();
  }
	
private:
  void startup_func();
};

#endif	// end of gprog.h
