#include <basic.h>
#include <tcstring.h>
#include <bstdio.h>
#include <new>
#include "ktext.h"

KTextLine::KTextLine(TC *str, KTextLine *p)
{
// b_printf("lineData new : size = %d \n", wb_strlen(str));
//	lineData = (TCODE *)new BYTE[sizeof(TCODE) * (wb_strlen(str) + 1)];
  lineData = new(std::nothrow) TC[tc_strlen(str) + 1];
  tc_strcpy(lineData, str);
  next = p;
}

int KTextLine::setTextLine(TC *str)
{
  delete [] lineData;
// b_printf("setTextLine \n");
//	lineData = (TCODE *)new BYTE[sizeof(TCODE) * (wb_strlen(str) + 1)];
  lineData = new(std::nothrow) TC[tc_strlen(str) + 1];
  tc_strcpy(lineData, str);
  return 0;
}


KText::KText()
{
  lineNum = 0;
// b_printf("KText constructor\n");
  pEnd = new(std::nothrow) KTextLine((TC[]){TNULL}, NULL);
  pStart = pEnd;
  pCursor = pStart;
}

int KText::setLine(TC *str)
{
  KTextLine *p;
// b_printf("start KTextLine \n");
  p = new(std::nothrow) KTextLine(str, NULL);
  if (p == NULL){
    printf("Can't new \n");
    return 1;
  }
  pEnd->setNext(p);
  pEnd = p;
  lineNum++;
  return 0;
}

// int KText::getTextLine(TC *str) -- Original, Ǥ⤳ʤȤ
int KText::getTextLine(TC*& str)
{
  if (pCursor == pStart){
    pCursor = pCursor->getNext();
  }
  if (pCursor != NULL){
    if (str != NULL){
      //delete str;
      delete [] str;
    }
    str = new(std::nothrow) TC[pCursor->getTextLineLen() + 1];
    if (str == NULL){
      printf("KText::getTextLine  do not reallocat memory area \n");
      return EOF;
    }
    tc_strcpy(str, pCursor->getTextLine());
    pCursor = pCursor->getNext();
//  b_printf("get one line : <%ls> \n", str);
    return tc_strlen(str);
  }
// b_printf("get one line : EOF \n");
  return EOF;
}

void KText::deleteAll()
{
  KTextLine *p;
  while (pStart != NULL){
    p = pStart;
    pStart = pStart->getNext();
// b_printf("KText::delete\n");
    delete p;
  }
  lineNum = 0;
  pEnd = new(std::nothrow) KTextLine((TC[]){TNULL}, NULL);
  pStart = pEnd;
  pCursor = pStart;
}

/*
extern "C"
void MAIN(M_EXECREQ *msg)
{
	KText data;
	LONG cnt, i;
	TCODE buf[100];
	
	for(cnt = 0; cnt < 20; cnt++){
		for(i = 0; i < 1000; i++){
			wb_sprintf((TCODE *)buf, (TCODE *)L"ͤ", (WORD)(cnt*1000+i));
//			b_printf("cnt = %d  i = %d\n", (WORD)cnt, (WORD)(cnt*100+i));
			data.setLine(buf);
		}
	}
	
	cnt = 0;
	while(data.getTextLine(buf) != EOF){
		if((cnt%100) == 0){
			b_printf("*%ls*\n", (TCODE *)buf);
		}
		cnt++;
	}
	
	data.deleteAll();
}
*/
