#include <basic.h>
#include <bstdio.h>
#include <btron/file.h>
#include <btron/dp.h>
#include <tad.h>
#include <tcode.h>
#include <tstring.h>
#include <btron/vobj.h>
#include <new>
#include "subc.h"
#include "qvt.h"
#include "krs232c.h"

#include "kdither.h"
#include "kim_data.h"
#include "kpixel.h"
#include "kpalet.h"

extern OutSider grovalFunc;

static int TAD16[16][3] = {
  {255, 255, 255},
  {  0,   0, 159},
  {  0, 239,   0},
  {  0, 239, 239},
  {255,   0,   0},
  {239,   0, 255},
  {223, 223,   0},
  {127, 127, 159},
  {223, 223, 223},
  {127, 159, 255},
  {191, 255, 175},
  {207, 255, 255},
  {255, 111, 111},
  {239, 143, 255},
  {239, 255, 159},
  {  0,   0,   0}	
};

void qv_command(W dd, B* buf)
{
  krs_flush(dd);
  krs_putc(dd, 0x05);
  while (*buf != 0x00){
    krs_putc(dd, *buf++);
  }
  krs_putc(dd, 0x06);
}

void qv_waitc(W dd, B c)
{
  while (krs_getc2(dd) != c){
    ;
  }
}

void qv_getYY(W dd, B* p)
{
  grovalFunc.println((TC[]){L"٥ǡ桡"});
  int ll = 450;
  int cnt3 = 128 * 3;
  while (ll > 0){
    B c = krs_getc2(dd);
    W cnt = krs_getc2(dd);
    if (cnt != 128){
      printf("receive data size error \n");
    }
    while (cnt > 0){
      c = krs_getc2(dd);
      if ((cnt3 % 3) != 0){
        *p++ = c;
      }
      cnt--;
      cnt3--;
      if (cnt3 == 0){
        cnt3 = 128 * 3;
      }
    }
    c = krs_getc2(dd);
    c = krs_getc2(dd);
    ll--;
    krs_putc(dd, 0x06);
    krs_getc2(dd);
    if ((ll % 10) == 0){
      grovalFunc.println((TC[]){L""});
    }
  }
  grovalFunc.println((TC[]){TK_BSLH, TK_n, 0});
}

void qv_getPP(W dd, B* p)
{
  grovalFunc.println((TC[]){L"Хǡ桡"});
  int line_cnt = QV10_PIC_SIZE_H;
  int ll = 75;
  while (ll > 0){
    krs_getc2(dd);
    W cnt = krs_getc2(dd);
    while (cnt > 0){
      W aa = krs_getc2(dd);
      *p = (B)(aa + 128);
      p += 2;
      line_cnt -= 2;
      cnt--;
      if (line_cnt == 0){
        line_cnt = QV10_PIC_SIZE_H;
        p += QV10_PIC_SIZE_H;
      }
    }
    krs_getc2(dd);
    krs_getc2(dd);
    ll--;
    krs_putc(dd, 0x06);
    krs_getc2(dd);
    if ((ll % 10) == 0){
      grovalFunc.println((TC[]){L""});
    }
  }
  grovalFunc.println((TC[]){TK_BSLH, TK_n, 0});
}


int interporationHV(unsigned char *data, int size_h, int size_v)
{
  for (int x = 0; x < size_h; x += 2){
    for (int y = 0; y < size_v; y += 2){
      int pos0 = y       * size_h + x;
      int pos1 = (y + 1) * size_h + x;
      int pos2 = (y + 2) * size_h + x;
      if ((y + 2) >= size_v){
        pos2 = pos0;
      }
      int p0 = (int)data[pos0];
      int p1 = (int)data[pos2];
      data[pos0] = (unsigned char)((p0 * 3 + p1) / 4);
      data[pos1] = (unsigned char)((p0 + p1 * 3) / 4);
    }
  }
  for (int y = 0; y < size_v; y++){
    for (int x = 0; x < size_h; x += 2){
      int pos0 = y * size_h + x;
      int pos1 = pos0 + 1;
      int pos2 = pos0 + 2;
      if ((x + 2) >= size_h){
        pos2 = pos0;
      }
      int p0 = (int)data[pos0];
      int p1 = (int)data[pos2];
      data[pos0] = (unsigned char)((p0 * 3 + p1) / 4);
      data[pos1] = (unsigned char)((p0 + p1 * 3) / 4);
    }
  }
  return 0;
}


int interporationHV(KImageData444 *data)
{
  interporationHV(data->get_pPb(), data->get_sizeH(), data->get_sizeV());
  interporationHV(data->get_pPr(), data->get_sizeH(), data->get_sizeV());
	
  return 0;
}

int save_picture(B* buf1, B* buf2, int page)
{
  grovalFunc.println((TC[]){L"¿¸桡"});
  static TC path[] = {
    TC_FDLM, L"ӣ٣"|TC_FDLM, L"Уңϣǣң͡£ϣ"|
    TC_FDLM, L""|TC_FDLM, L"ѣ֣ѻ"
  };
  static VOBJSEG vs0 = {{{0, 0, 0, 0}}, 0, 0, 0xfffffff, 0xfffffff, 0, 0, 0};
  static VFPTR dummy;
  dummy.vobj = &vs0;
  LINK lnk0, lnk1;

  // wb_sprintf
  char namebuf[42];
  TC name[21];
  sprintf(namebuf, "ѣ֣%2d", page);
  eucstotcs(name, (B*)namebuf);
	
  W rtn = get_lnk(path, &lnk0, F_NORM);
  if (rtn < 0){
    grovalFunc.println((TC[]){L"ʡˡ顼"});
    return 1;
  }
  W vid = oreg_vob((VLINK*)&lnk0, dummy.vobj, oget_env(&lnk1), V_NODISP);
  W fd = ocre_obj(vid, name, NULL, NULL, 1);
  odel_vob(vid, 0);
	
  FIGSEG fig_seg;
  IMAGESEG image_seg;
  UW base_off[3];
  int image_head_size = sizeof(IMAGESEG) + sizeof(base_off);
	
  static TC tad_head[] = {0xffe0, 6, 0, 2, 0x0120};
  static TC fig_head[] = {0xffe3, sizeof(FIGSEG)};
  static TC image_head[] = {0xffe5, sizeof(IMAGESEG)};
  static TC fig_end[] = {0xffe4, 0};
  static B ext[] = { 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00};
	
  fig_seg.view.c.right  = QV10_PIC_SIZE_H;
  fig_seg.view.c.bottom = QV10_PIC_SIZE_V;
  fig_seg.view.c.left   = 0;
  fig_seg.view.c.top    = 0;
  fig_seg.draw.c.right  = QV10_PIC_SIZE_H;
  fig_seg.draw.c.bottom = QV10_PIC_SIZE_V;
  fig_seg.draw.c.left   = 0;
  fig_seg.draw.c.top    = 0;
  fig_seg.h_unit        = 0xff88;
  fig_seg.v_unit        = 0xff88;
  fig_seg.ratio         = 1;
	
  image_seg.view.c.right    = QV10_PIC_SIZE_H;
  image_seg.view.c.bottom   = QV10_PIC_SIZE_V;
  image_seg.view.c.left     = 0;
  image_seg.view.c.top      = 0;
  image_seg.draw.c.right    = QV10_PIC_SIZE_H;
  image_seg.draw.c.bottom   = QV10_PIC_SIZE_V;
  image_seg.draw.c.left     = 0;
  image_seg.draw.c.top      = 0;
  image_seg.h_unit          = 0xff88;
  image_seg.v_unit          = 0xff88;
  image_seg.slope           = 0;
  image_seg.color           = 0x09;
  image_seg.cinfo[0]        = 0;
  image_seg.cinfo[1]        = 0;
  image_seg.cinfo[2]        = 0;
  image_seg.cinfo[3]        = 0;
  image_seg.extlen          = 8L;
  image_seg.rowbytes        = ((QV10_PIC_SIZE_H + 15) / 16) * 2;
  image_seg.extend          = image_seg.rowbytes * QV10_PIC_SIZE_V * 4 + image_head_size;
  image_seg.mask            = 0L;
  image_seg.compac          = 0;
  image_seg.planes          = 4;
  image_seg.pixbits         = 0x0101;
  image_seg.bounds.c.right  = QV10_PIC_SIZE_H;
  image_seg.bounds.c.bottom = QV10_PIC_SIZE_V;
  image_seg.bounds.c.left   = 0;
  image_seg.bounds.c.top    = 0;
  image_seg.base_off[0]     = image_head_size;
	
  base_off[0] = (image_seg.rowbytes * QV10_PIC_SIZE_V * 1 + image_head_size);
  base_off[1] = (image_seg.rowbytes * QV10_PIC_SIZE_V * 2 + image_head_size);
  base_off[2] = (image_seg.rowbytes * QV10_PIC_SIZE_V * 3 + image_head_size);
	
  image_head[1] = image_seg.extend + sizeof(ext);
	
  apd_rec(fd, (B*)tad_head, sizeof(tad_head), 1, 0, 0);
  see_rec(fd, -1, -1, NULL);
	
  wri_rec(fd, -1, (B*)fig_head, sizeof(fig_head), NULL, NULL, 0);
  wri_rec(fd, -1L, (B*)&fig_seg, sizeof(FIGSEG), NULL, NULL, 0);
	
  wri_rec(fd, -1L, (B*)image_head, sizeof(image_head), NULL, NULL, 0);
  wri_rec(fd, -1L, (B*)&image_seg, sizeof(IMAGESEG), NULL, NULL, 0);
  wri_rec(fd, -1L, (B*)&base_off, sizeof(base_off), NULL, NULL, 0);
	
  int sizesize = image_seg.rowbytes * QV10_PIC_SIZE_V;
  B *buf = new(std::nothrow) B[sizesize];
  for (int plane = 0; plane < 4; plane++){
    B *p1 = buf1;
    B *p2 = buf2;
    B *pp = buf;
    B data = 0;
    for (int y = 0; y < QV10_PIC_SIZE_V2; y++){
      for (int x = 0; x < QV10_PIC_SIZE_H; x++){
        B c = *p1++;
        c = c >> plane;
        c &= 0x01;
        data |= (c << (7 - x % 8));
        if ((x % 8) == 7){
          *pp++ = data;
          data = 0;
        }
      }
    }
    for (int y = 0; y < QV10_PIC_SIZE_V2; y++){
      for (int x = 0; x < QV10_PIC_SIZE_H; x++){
        B c = *p2++;
        c = c >> plane;
        c &= 0x01;
        data |= (c << (7 - x % 8));
        if ((x % 8) == 7){
          *pp++ = data;
          data = 0;
        }
      }
    }
    wri_rec(fd, -1, (B*)buf, sizesize, NULL, NULL, 0);
    grovalFunc.println((TC[]){L""});
  }
  delete [] buf;

  wri_rec(fd, -1, (B*)ext, sizeof(ext), NULL, NULL, 0);
  wri_rec(fd, -1, (B*)fig_end, sizeof(fig_end), NULL, NULL, 0);
	
  cls_fil(fd);
  grovalFunc.println((TC[]){TK_BSLH, TK_n, 0});
	
  return 0;
}


int qv_getp(W dd, int page)
{
  KImageData444 *im_up  = new(std::nothrow) KImageData444(QV10_PIC_SIZE_H, QV10_PIC_SIZE_V2);
  KImageData444 *im_low = new(std::nothrow) KImageData444(QV10_PIC_SIZE_H, QV10_PIC_SIZE_V2);
	
  unsigned char *pYY_up  = im_up->get_pYY();
  unsigned char *pYY_low = im_low->get_pYY();
  unsigned char *pPb_up  = im_up->get_pPb();
  unsigned char *pPb_low = im_low->get_pPb();
  unsigned char *pPr_up  = im_up->get_pPr();
  unsigned char *pPr_low = im_low->get_pPr();
	
  qv_command(dd, "ML");
  krs_putc(dd, 0x12);
  qv_waitc(dd, 0x02);
	
  qv_getYY(dd, (B*)pYY_up);
  qv_getYY(dd, (B*)pYY_low);
  qv_getPP(dd, (B*)pPb_up);
  qv_getPP(dd, (B*)pPb_low);
  qv_getPP(dd, (B*)pPr_up);
  qv_getPP(dd, (B*)pPr_low);
	
  krs_putc(dd, 0x06);
	
//	interporationHV(im_up, im_low);
  interporationHV(im_up);
  interporationHV(im_low);
	
  unsigned char *buf_up  = new(std::nothrow) unsigned char[QV10_PIC_SIZE_H * QV10_PIC_SIZE_V2];
  unsigned char *buf_low = new(std::nothrow) unsigned char[QV10_PIC_SIZE_H * QV10_PIC_SIZE_V2];
	
  KPallet *pallet = new(std::nothrow) KPallet(16);
  for (int ii = 0; ii < 16; ii++){
    pallet->put_color(ii, KRGB(TAD16[ii][0], TAD16[ii][1], TAD16[ii][2]));
  }
	
  KDither *dither = new(std::nothrow) KDither(pallet);
//	dither->calc_ditherFloyd(buf_up, buf_low, im_up, im_low);
  dither->calc_ditherFloyd(buf_up, im_up);
  dither->calc_ditherFloyd(buf_low, im_low);
  delete dither;
	
  save_picture((B*)buf_up, (B*)buf_low, page);
	
  krs_flush(dd);
  delete buf_up;
  delete buf_low;
  delete pallet;
  delete im_up;
  delete im_low;
	
  return 0;
}


