#ifndef _REAL_OBJECT_H
#define	_REAL_OBJECT_H

#include "v_obj.h"
#include "record.h"

class RealObject;
class TADMainRecord;
class RealObject;

class Segment
{
  friend TADMainRecord;
	
protected:
  KText *segData;
  VirtualObject *vObj;
  int segID;
  int length;
  TC *Buff, *unBuff;
  int pGet, punGet;
	
public:
  Segment(TC *str);
  Segment();
  virtual ~Segment();
	
  virtual TC getw();
  TC ungetw(TC c);
  int getKind() {
    return segID;
  }
  LINK* get_vobj();
  int set_len(int l) {
    return (length = l);
  }
  int get_len() {
    return length;
  }
  virtual B* get_seg(B* str);
	
protected:
  int set_data(TC *str) {
    return segData->setLine(str);
  }
  void set_vobj(VirtualObject *p) {
    vObj = p;
  }
	
private:
  void del_data() {
    if (segData != NULL){
      delete segData;
    }
  }

  int getBuff();
};


class Fusen : public Segment
{
public:
  Fusen(TC *str, int n);
  virtual ~Fusen();
	
  virtual TC getw();
  virtual B* get_seg(B* str);
};


class TADMainRecord
{
  friend RealObject;
	
  LINK* plink;
  W fd;
  RecordBuffer *recBuff;
  Segment *seg;
  RealObject *parent;
	
public:
  TADMainRecord(LINK* lnk, RealObject *rp);
  ~TADMainRecord();
	
protected:
  Segment* get_segment();
  int read_seg();
  int get_seglen();
  int read_rec();
  void close_file();
  void del_seg() {
    if (seg != NULL){
      delete seg;
      seg = NULL;
    }
  }
};


class RealObject
{
  friend TADMainRecord;
	
  LINK* plink;
  VirtualObjectList *vobjList;
  TADMainRecord *mainRec;
  TC name[21];
	
public:
  RealObject(LINK* lnk);
  ~RealObject();
	
  Segment* get_segment(){
    return mainRec->get_segment();
  }
  TC *get_fname() {
    return name;
  }
	
protected:
  int read_vobj();
  VirtualObject* getVirtualObject() {
    return vobjList->getVirtualObject();
  }
};

#endif	//	end of r_obj.h
