#include <basic.h>
#include <btron/file.h>
#include <bstdio.h>
#include "ktext.h"
#include "record.h"

int RecordBuffer::read_buff()
{
  W r_size;
	
  if (offset >= recSize){
    dataP = 0;
    return 0;
  }
  rea_rec(fd, offset, (B*)data, BUFFER_SIZE, &r_size, &subType);
  offset += BUFFER_SIZE;
	
  if (offset >= recSize){
    dataSize = (recSize - (offset - BUFFER_SIZE)) / 2;
  }
  else{
    dataSize = BUFFER_SIZE / 2;
  }
  dataP = 0;
  return dataSize;
}

RecordBuffer::RecordBuffer(W f)
{
  fd = f;
  offset = 0;
  udataP = 0;
	
  W err;
  if ((err = fnd_rec(fd, F_TOPEND, 0x00000002, 0, NULL)) < 0){
    printf("Can't find type 1 record err = %d \n", err);
    return;
  }
  rea_rec(fd, 0, NULL, 0, &recSize, &subType);
  read_buff();
}

TC RecordBuffer::ungetw(TC c)
{
  udataP--;
  ungetData[-udataP] = c;
	
  return c;
}

TC RecordBuffer::getw()
{
  TC c;
  if (udataP < 0){
    c = ungetData[-udataP];
    udataP++;
  }
  else {
    if (dataP >= dataSize){
      read_buff();
    }
    if (dataSize == 0){
      return TNULL;
    }
    c = data[dataP++];
  }
  return c;
}

