#include <basic.h>
#include <tstring.h>
#include <btron/dp.h>
#include <tcode.h>
#include "subc.h"

static int cursorX = 0;
static int cursorY = 0;

static int maxX = CHAR_NUM_X;
static int maxY = CHAR_NUM_Y;

static TC screenBuff[CHAR_NUM_X][CHAR_NUM_Y];

static W gid = -1;

void locate(int x, int y)
{
  if (x < 0){
    x = 0;
  }
  else if (x >= maxX){
    x = maxX - 1;
  }
  cursorX = x;
	
  if (y < 0){
    y = 0;
  }
  else if (y >= maxY){
    y = maxY - 1;
  }
  cursorY = y;
}

void set_one_line_buffer(int x, int y, TC* str)
{
  int xlen = tc_strlen(str);
  int cnt, xp;
	
  if ((x < 0) || (x >= maxX) || (y < 0) || (y >= maxY)){
    return;
  }
	
  for (cnt = 0, xp = x; cnt < xlen; cnt++, xp++){
    if(xp >= maxX){
      break;
    }
    screenBuff[xp][y] = str[cnt];
  }
}

void display_one_line(int x, int y, int xlen)
{
  TC str[CHAR_NUM_X];
  int cnt, xp;
  int gx, gy;
	
  if ((x < 0) || (x >= maxX) || (y < 0) || (y >= maxY)){
    return;
  }
	
  for (cnt = 0, xp = x; cnt < xlen; cnt++, xp++){
    if (xp >= maxX){
      break;
    }
    str[cnt] = screenBuff[xp][y];
  }
	
  gx = x * CHAR_SIZE_H;
  gy = (y + 1) * CHAR_SIZE_V - 1;
  gdra_stp(gid, gx, gy, str, xlen, G_STORE);
}

void display(int x1, int y1, int x2, int y2)
{
  if (y1 < 0){
    y1 = 0;
  }
  if (y2 >= maxY){
    y2 = maxY - 1;
  }
  for (int i = y1; i <= y2; i++){
    display_one_line(x1, i, x2 - x1 + 1);
  }
}

void redisplay()
{
  display(0, 0, maxX, maxY);
}

void println(TC *str)
{
  int len = tc_strlen(str);
	
  set_one_line_buffer(cursorX, cursorY, str);
  display_one_line(cursorX, cursorY, len);
  cursorX += len;
  if (cursorX >= maxX){
    cursorX = 0;
  }
}

void clear_screen()
{
  for (int j = 0; j < maxY; j++){
    for (int i = 0; i < maxX; i++){
      screenBuff[i][j] = TK_KSP;
    }
    display_one_line(0, maxX, j);
  }
}

void init_screen(W g)
{
  gid = g;
  clear_screen();
}

