#ifndef _TEXTSCREEN_H
#define _TEXTSCREEN_H

#include <basic.h>
#include "subc.h"

class TextScreen
{
  W gid;
  W wid;
  //	FONTSPEC fs;
  int cursorX, cursorY;
  int charSizeX, charSizeY;
  int maxX, maxY;
  TC screenBuff[CHAR_NUM_X * CHAR_NUM_Y];
	
public:
  //  - id: WID
  TextScreen(W id);

  ~TextScreen(){}

  // ꤷ֤˰ư
  void locate(int x, int y);

  void redisplay(){
    disp_rect(0, 0, maxX, maxY);
  }

  void redisplay(int x1, int y1, int x2, int y2);
  void cls();
  void line_cls(int n);

  void println(TC *str);
  void println(int d);

  int get_curX() {
    return cursorX;
  }

  int get_curY() {
    return cursorY;
  }
	
protected:

  int set_txpos(int x);
  int set_typos(int y);

  // graphics x --> text x
  int get_txpos(int x) {
    return (x / charSizeX);
  }

  // graphics y --> text y
  int get_typos(int y) {
    return ((y + 1) / charSizeY - 1);
  }

  // text x --> graphics x
  int get_gxpos(int x) {
    return (x * charSizeX);
  }

  // text y --> graphics y
  int get_gypos(int y) {
    return ((y + 1) * charSizeY - 1);
  }

  void text_scrol();

  int get_add(int x, int y) {
    return ((maxX + 1) * y + x);
  }

  void disp_line(int x, int y, int len);

  int chk_size(int x, int min, int max);

  int chk_xpos(int x) {
    return chk_size(x, 0, maxX);
  }

  int chk_ypos(int y) {
    return chk_size(y, 0, maxY);
  }

  void disp_rect(int x1, int y1, int x2, int y2);

  int add_xpos();
  int add_ypos();

  int copy_str(TC *str, int n);

};

#endif	//	end of textscr.h

